function switchToRunningShow(channel, button)
{
	if (eyetvIsCurrentlyPlaying != "")
	{
		var oldbutton = document.getElementById("playingButton_" + eyetvIsCurrentlyPlaying);
		if (undefined != oldbutton) oldbutton.setAttribute("src", "Images/EyeTV_readyToPlay.png");
	}
	eyetvIsCurrentlyPlaying = channel;
	button.setAttribute("src", "Images/EyeTV_progressing.png");
	switchToEyeTVChannel(eyetvChannels[channel]);
	button.setAttribute("src", "Images/EyeTV_playing.png");
}

function switchToEyeTVChannel(channel)
{
	var eyetvwasrunning = eyeTVIsRunning();
	if (!eyetvwasrunning)
	{
		asTell("activate");
		while (!eyeTVIsRunning())
		{
			// wait
		}
	}
	asTell("set the current channel to (the channel number of (the first channel whose name contains \"" + channel + "\"))");
}

function deleteRecordTimerForShow(channel, showname, showlength, button, timestamp)
{	
	var temp_img = new Image();
	temp_img.src = "Images/EyeTV_progressing2.png";
	button.setAttribute("src", temp_img.src);
	
	var recordID = FernsehPlugin.recordingUniqueIDForChannel(eyetvChannels[channel], ""+timestamp);
	if (undefined == recordID)
	{
		alert("Ouch, couldn't find Unique ID for show. Sorry.");
		return;
	}
		
	asTell("delete (every program whose unique ID is " + recordID + ")");
	
	button.setAttribute("src", "Images/EyeTV_readyToRecord.png");
	button.setAttribute('title', 'Sendung aufnehmen');
	button.setAttribute("onclick", "setRecordTimerForShow(\"" + channel + "\", \"" + showname + "\", \"" + showlength + "\", this, " + timestamp + ");");
}

function setRecordTimerForShow(channel, showname, showlength, button, timestamp)
{	
	var temp_img = new Image();
	temp_img.src = "Images/EyeTV_progressing2.png";
	button.setAttribute("src", temp_img.src);
	
	var date = new Date();
	date.setTime(timestamp);

	var ourDateString = date.toLocaleString();
	
	prog = new eyeTVSchedule();
	prog.starttime = ourDateString;
	prog.duration = (Math.abs(showlength) * 60);
	prog.stationname = eyetvChannels[channel];
	prog.title = showname;
	prog.createSchedule();
	
	if ("" == button) return; // DEBUG
	button.setAttribute("src", "Images/EyeTV_recording.png");
	button.setAttribute('title', 'Sendung wird aufgenommen');
	button.setAttribute("onclick", "deleteRecordTimerForShow(\"" + channel + "\", \"" + showname + "\", \"" + showlength + "\", this, " + timestamp + ");");
}

function indexOfStation(tvtodayname)
{
	var availChannels = getEyeTVChannels();
	var eyetvChannelName = eyetvChannels[tvtodayname];
	return indexOfObjectInArray(availChannels, eyetvChannelName);
}

function indexOfObjectInArray(array, object)
{
	for (i = 0; i < array.length; i++)
	{
		if (array[i] == object) return i;
	}
	return -1;
}

function eyeTVChannelsAssigned()
{
	var numAssignedChannels = 0;
	for (var channel in eyetvChannels)
	{
		numAssignedChannels++;
	}
	return (numAssignedChannels > 0);
}

function getEyeTVChannels()
{
	return FernsehPlugin.eyeTVChannels();
}

function eyeTVIsRunning()
{
	return (eyeTVrunning = widget.system("ps -ulwwx | grep \"" + FernsehPlugin.appNameForEyeTV() + ".app/Contents/MacOS/EyeTV\" | grep -v grep | wc -l", null).outputString.indexOf("1") == 7);
}

function currentStation()
{
	if (!eyeTVIsRunning()) return "";
	var currStation = FernsehPlugin.currentStation();
	
	for (var channel in eyetvChannels)
	{
		if (eyetvChannels[channel] == currStation) return channel;
	}
	return "";
}

// Applescript wrappers, partially copy & paste from Elgato sample code

var kMissingValueString = "missing value"; // string constant returned, if an AppleScript didn't succeed.
var appName = "EyeTV";

// Send a command to Application
function asTell(command) {
	if (FernsehPlugin) FernsehPlugin.appleScript('tell application "' + appName + '"\n try\n' + command + '\n on error\n return "' + kMissingValueString + '"\n end try\n end tell\n');
}

function eyeTVSchedule() {
	
	this.starttime = "";
	this.duration = 30;
	this.title = "Untitled";
	this.stationname = "";
	
	this.createSchedule = function() {
		cmd = 'make new program with properties {start time:date "' +
				this.starttime + '", duration:' + 
				this.duration + ', title:"' + 
				this.title + 
				'", channel number:(the channel number of (the first channel whose name contains "' + this.stationname + '")) as integer' +
				'}';
		asTell(cmd);
	}	
}
