//
// FernsehWidget
// Von Pascal Pfiffner und Sebastian Krauß
//

var req;
var previous; // url für die vorigen sendungen
var further; // url für die nächsten sendungen
var currentlyloading;
var progressAnimationTimer;
var currentID;
var currentShowDescURL;
var isSearchResult;
var lastSearchDate;
var isQuickAccessSearch;
var quickAccessDay;
var quickAccessHour;
var elapsedTimeCanvasses;
var eyetvEnabled;
var eyetvChannels = new Array();
var eyetvIsCurrentlyPlaying;
var previousChosenShortcut;

// array with the channels
var channels_main = new Object();
var channels_two = new Object();

// variables needed to verify the date
var numNextPages;
var previousNumPages;
var firstShowStamp;
var previousShowTime;
var daysPastMidnight;

// Which show was previously shown?
var previousShowObject;
var previousShowClass;

var furtherArray;
var previousArray;

var waitingForChannels;
var waitingForTime;
var waitingForDay;

var numEntriesJetztUndGleich;

var newVersionRequest;
var newVersionUrl;

var showErrorWhenGettingShows;
var errorOccurredWhenGettingShows;

var alreadySearchedInCache;
var numDaysToPrecache;


function loaded()
{
	startCacheIndicator();
	setCacheIndicatorText("Starten...");
	
	forwardCacheAborted = false;
	alreadySearchedInCache = false;
	showErrorWhenGettingShows = true;
	currentID = 0;
	currentlyloading = false;
	isSearchResult = false;
	numNextPages = 0;
	previousNumPages = 0;
	elapsedTimeCanvasses = new Array();
	
	// resize the widget
	if(window.widget) {
		var winX = widget.preferenceForKey("windowX");
		var winY = widget.preferenceForKey("windowY");
		if((undefined != winX) && (undefined != winY))
			window.resizeTo(winX, winY);
	}
	
	
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));

	// create buttons
	createGenericButton(document.getElementById("eyetv_start_button"), "Sender zuweisen", startEyeTVAndSwitchToPrefs, 120);
	createGenericButton(document.getElementById("done"), "Fertig", savePrefs);
	createGenericButton(document.getElementById("clear_cache_button"), "Cache l&ouml;schen", clearCache);
	
	// days to precache
	var opt = document.getElementById("numDaysToPrecache");
	var optvalue = widget.preferenceForKey("numDaysToPrecache");
	if(undefined != optvalue)
		selectValue(opt, optvalue);
	numDaysToPrecache = getNumDaysToPrecache();
	
	// setup Prefs:
	// default day to show
	var opt = document.getElementById("ztag");
	var optvalue = widget.preferenceForKey("day");
	if (undefined != optvalue) selectValue(opt, optvalue);
	
	// default time to show
	opt = document.getElementById("uhrzeit");
	optvalue = widget.preferenceForKey("hour");
	if (undefined != optvalue) selectValue(opt, optvalue);
	
	// default channelGroup to show
	var opt = document.getElementById("defaultChannelGroup");
	var optvalue = widget.preferenceForKey("defaultChannelGroup");
	if(undefined != optvalue)
		selectValue(opt, optvalue);
	
	// number of channels to show
	opt = document.getElementById("numEntriesPerPage");
	optvalue = widget.preferenceForKey("numEntriesPerPage");
	if(undefined != optvalue)
		selectValue(opt, ""+optvalue);
	
	optvalue = widget.preferenceForKey("showShortDesc");
	if ((optvalue != undefined) && (optvalue == "1")) document.getElementById("kurzInfoStandard").checked = true;
	
	// Channel Grouping
	channels_main = getChannelGroup("channels_main");
	channels_two = getChannelGroup("channels_two");
	
	// make sure at least channels_main is filled with a couple of default values for the first start
	var numAssignedMain = 0;
	for (var key in channels_main) { numAssignedMain++; }
	
	if (0 == numAssignedMain)
	{
		var parentDiv = 'channels_main';
		
		addChannelToGroup("ARD", "ARD", parentDiv);
		addChannelToGroup("ZDF", "ZDF", parentDiv);
		addChannelToGroup("SAT.1", "SAT.1", parentDiv);
		addChannelToGroup("RTL", "RTL", parentDiv);
		addChannelToGroup("PRO 7", "PRO 7", parentDiv);
		addChannelToGroup("KABEL 1", "Kabel 1", parentDiv);
		addChannelToGroup("VOX", "VOX", parentDiv);

		channels_main["ARD"] = "ARD";
		channels_main["ZDF"] = "ZDF";
		channels_main["SAT.1"] = "SAT.1";
		channels_main["RTL"] = "RTL";
		channels_main["PRO 7"] = "PRO 7";
		channels_main["KABEL 1"] = "Kabel 1";
		channels_main["VOX"] = "VOX";

		if ("CH" == currentLocale())
		{
			addChannelToGroup("SF1", "SF1", parentDiv);
			addChannelToGroup("SF2", "SF2", parentDiv);
			addChannelToGroup("ORF 1", "ORF 1", parentDiv);
			channels_main["SF1"] = "SF1";
			channels_main["SF2"] = "SF2";
			channels_main["ORF 1"] = "ORF 1";
		} else if ("AT" == currentLocale()) {
			addChannelToGroup("ORF 1", "ORF 1", parentDiv);
			addChannelToGroup("ORF 2", "ORF 2", parentDiv);
			channels_main["ORF 1"] = "ORF 1";
			channels_main["ORF 2"] = "ORF 2";
		} else {
			addChannelToGroup("NDR", "NDR", parentDiv);
			channels_main["NDR"] = "NDR";
		}
	}
	
	// Growl
	optvalue = widget.preferenceForKey("growlSupport");
	if ((optvalue != undefined) && (optvalue == "1") && FernsehPlugin && (FernsehPlugin.canUseGrowlNotification())) 
	{
		document.getElementById("growlSupport").checked = true;
		// no reason to worry, even if set to true, the plugin
		// ignores this if Growl is not installed and/or running
		FernsehPlugin.setUsesGrowlNotification(true);	
	}
	if (!(FernsehPlugin && FernsehPlugin.canUseGrowlNotification())) {
		document.getElementById("growlSupport").disabled = true;
		document.getElementById("growlSupport").checked = false;
	}
	
	// Alerts
	opt = document.getElementById("erinnerung");
	optvalue = widget.preferenceForKey("reminder");
	if (undefined != optvalue)
	{
		selectValue(opt, optvalue);
		if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(optvalue);
		// 120 is the default in the plugin and in the gui.
		// no need to explicitly set it.
	}
	
	// EyeTV Channels
	eyetvChannels = getEyeTVChannelAssigns();
	
	// populate sounds
	var alarmSound = FernsehPlugin.timerSound();
	var selector = document.getElementById('alarmton');
	var sounds = FernsehPlugin.validSounds();
	var currentLibrary = 0;
	var a = 1;
	for(i = 0; i < sounds.length; i++) {
		var components = sounds[i].split("/");
		
		// new library; add separator
		if(currentLibrary != components[1]) {
			selector.appendChild(document.createElement("option"));
			selector.options[a].value = "";
			selector.options[a].innerHTML = "&mdash;&mdash;&mdash;&mdash;&mdash;&mdash;";
			a++;
		}

		soundname = components[components.length-1];
		soundname = soundname.substring(0, soundname.indexOf(".", soundname.length -6));
		
		selector.appendChild(document.createElement("option"));
		selector.options[a].value = sounds[i];
		selector.options[a].innerHTML = (soundname.length > 0) ? soundname : "Systemsound";
		
		// select the right one
		if(sounds[i] == alarmSound) {
			selector.options[a].selected = true;
		}
		
		currentLibrary = components[1];
		a++;
	}
	
	// elgato EyeTV support
	eyetvEnabled = widget.preferenceForKey("eyetvEnabled");
	if((undefined != eyetvEnabled) && (eyetvEnabled == 1))
	{
		document.getElementById("eyetvSupport").checked = true;
		if (FernsehPlugin) FernsehPlugin.setEyeTVEnabled(true);
		if (FernsehPlugin) appName = FernsehPlugin.appNameForEyeTV();
		//alert(FernsehPlugin.appNameForEyeTV());
	}
		
	if (FernsehPlugin && !FernsehPlugin.canUseEyeTV())
	{
		document.getElementById("eyetvSupport").disabled = true;
	}
	
	// select necessary layer
	switchToPrefSection("pref_form");
	
	if(window.widget)
	{
		widget.onshow = onShow;
		widget.onhide = onHide;
		widget.onremove = cleanUp;
	}
	
	previousChosenShortcut = "-";
	numEntriesJetztUndGleich = 3;
	if (undefined != widget.preferenceForKey("numGroupEntries")) numEntriesJetztUndGleich = Math.abs(widget.preferenceForKey("numGroupEntries"));
	
	cacheBase = FernsehPlugin.cachePath() + "/";
	
	stopCacheIndicator();
	
	// DISPLAY SHOWS FROM HERE ON
	
	setTimeout("updateTVListing();",1);
	setTimeout("checkForNewVersion();",2000);	
}	

function checkForNewVersion()
{
	var requesturl = "http://homepage.mac.com/sebastian.krauss/Fernsehenversion";
	
	newVersionRequest = new XMLHttpRequest;
	newVersionRequest.onreadystatechange = checkForNewVersionDone;
	newVersionRequest.open("GET", requesturl, true);
	newVersionRequest.setRequestHeader("Cache-Control", "no-cache");
	newVersionRequest.send(null);
}

function checkForNewVersionDone()
{
	if ((newVersionRequest.readyState == 4) && (newVersionRequest.status >= 200) && (newVersionRequest.status < 400))
	{
		var answer = newVersionRequest.responseText;
		var components = answer.split("\n");
		
		var otherVersion = components[0];
		newVersionUrl = components[1];
		var newDesc = components[2];
		
		var localReq = new XMLHttpRequest(); 
		localReq.open("GET", "Info.plist", false); 
		localReq.send(null); 
		
		var infoPlist = localReq.responseText; 
		
		var versionRegEx = /<key>CFBundleVersion<\/key>\s*<string>([^<]*)<\/string>/;
		var versionRaw = infoPlist.match(versionRegEx);
		if (undefined == versionRaw)
		{
			alert("An error occurred while checking the local version. Assuming local version up-to-date.");
			return;
		}
		var thisVersion = versionRaw[1];
		
		if (thisVersion == otherVersion)
		{
			//alert("Version check performed. No new version available.");
			return;
		}
		showDialog("Eine neue Version von &#8222;Fernsehen&#8221; ist verf&uuml;gbar.<br>Ihre Version: " + thisVersion + " &mdash; Neue Version: " + otherVersion + "<br><br>" + newDesc + "<br><br>M&ouml;chten Sie die neue Version jetzt laden?", "Ignorieren", blendDialogOut, "Laden", getNewVersion);
	}
}

function getNewVersion()
{
	blendDialogOut();
	widget.openURL(newVersionUrl);	
}

function forwardCache()
{
	if (networkErrorOccurred) return;

	var channels = keysFromHash(channels_main).concat(keysFromHash(channels_two));
	
	for (var i = 0; i < numDaysToPrecache+1; i++)
	{
		if (!cachedDataAvailable(channels, i))
		{
			backgroundCachedData(channels, i, forwardCache);
			return;
		}
	}
}

function getListingDay()
{
	var opt = document.getElementById("ztag");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getListingTime()
{
	var opt = document.getElementById("uhrzeit");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getDefaultChannelGroup() {
	var opt = document.getElementById("defaultChannelGroup");
	var ret = opt.options[opt.selectedIndex].value;
	return ret;
}

function getNumberOfEntriesToDisplay() {
	var opt = document.getElementById("numEntriesPerPage");
	var ret = Math.abs(opt.options[opt.selectedIndex].value);
	return (ret > 50 || ret < 1) ? 30 : ret;
}

function getChannelGroup(group) {
	var parent = document.getElementById(group);
	if(!parent)
		return;
	
	var temphash = new Object();
	if(window.widget && widget.preferenceForKey(group)) {
		var grouparr = widget.preferenceForKey(group).split("|");
		var properties;
		for(i = 0; i < grouparr.length; i++) {
			properties = grouparr[i].split(":");
			if(properties[0].length > 0) {
				temphash[properties[0]] = properties[1];
				showChannelInGroup(properties[0], properties[1], group);
			}
		}
	}
	return temphash;
}

function getNumDaysToPrecache() {
	var opt = document.getElementById("numDaysToPrecache");
	var ret = Math.abs(opt.options[opt.selectedIndex].value);
	return ret;
}

function getEyeTVChannelAssigns() {
	if(window.widget)
		optvalue = widget.preferenceForKey("eyetvChannels");
	
	var tmpChannels;
	var curChannel;
	var tmpArray;
	var channels = new Object();
	
	if(undefined != optvalue) {
		tmpChannels = optvalue.split("////");
		tmpChannels.pop();
		
		for(i = 0; i < tmpChannels.length; i++) {
			curChannel = tmpChannels[i];
			tmpArray = curChannel.split(">>>>");
			channels[tmpArray[0]] = tmpArray[1];
		}
	}
	
	return channels;
}

// dummy function for pre-caching data
// don't delete!
function noop()
{
}

function getShowsFromArray(array)
{
	var channels = array[0];
	var listingday = array[1];
	var numEntries = array[2];
	var startindex = array[3];
	
	var showsErrorCaching = new Array();
	
	var allShows = new Array();
	var keyedShows = new Object();

	for (var channel in channels)
	{
		var shows = cachedData(channel, listingday);

		if(!shows)
		{
			showsErrorCaching.push(channel);
			errorOccurredWhenGettingShows = true;
			//alert("Could not retrieve Data for channel " + channel);
			continue;
		} else keyedShows[channel] = shows;

		for (var thisshow in shows)
		{
			allShows.push(thisshow + " " + channel);
		}
	}
	
	//if(showsErrorCaching.length > 0) showDialog("Daten f&uuml;r " + showsErrorCaching.length + " Sender konnten nicht geladen werden, da keine Verbindung zum Internet besteht.<br>Die angezeigten Daten sind unvollst&auml;ndig.", "OK", blendDialogOut);
	
	// sortieren.
	allShows.sort();
	
	var i = startindex;
	if (0 > i) i = allShows.length + i;
	
	var max = i + numEntries;
	var nextDay = 0;
	if (max >= allShows.length)
	{
		nextDay = max - allShows.length;
		max = allShows.length;
	}
	
	var retValue = new Array();
	for (var j = i; j < max; j++)
	{
		var thisentry = allShows[j];
		var components = thisentry.split(" ");
		var time = components[0];
		components.shift();
		var channel = components.join(" ");
		var temp = keyedShows[channel];
		var thisshow = temp[time];
		thisshow["time"] = time;
		thisshow["listingday"] = "" + listingday;
		thisshow["channel"] = channel;
		retValue.push(thisshow);
	}
	
	var furtherstartidx = max;
	var furtherlistingday = listingday;
	
	var nextDayOK = true;
	
	if (furtherstartidx >= allShows.length)
	{
		furtherstartidx -= allShows.length;
		furtherlistingday = listingday + 1;
		if (8 == listingday) furtherlistingday = 0;
		if (8 == furtherlistingday) nextDayOK = false;
	}
	var previousstartidx = i - numEntries;
	var previouslistingday = listingday;
	if (0 > previousstartidx)
	{
		// previousstartidx MUST be left negative. getShowsFromArray deals with that.
		previouslistingday--;
	}

	if (-1 == previouslistingday) previouslistingday = 8;
	furtherArray = new Array (channels, furtherlistingday, getNumberOfEntriesToDisplay(), furtherstartidx);
	if (!nextDayOK) furtherArray = undefined;
	previousArray = new Array (channels, previouslistingday, getNumberOfEntriesToDisplay(), previousstartidx);
	if (7 == previouslistingday) previousArray = undefined;
	
	if (nextDay > 0)
	{
		if (listingday == 7) return retValue;
		if (listingday == 8) listingday = 0;
		else listingday += 1;
	
		var othershows = getShows(channels, "00.00", listingday, nextDay);
		for (var i = 0; i < othershows.length; i++)
		{
			retValue.push(othershows[i]);
		}
	}
	if (-1 == previouslistingday) previouslistingday = 8;
	previousArray = new Array (channels, previouslistingday, getNumberOfEntriesToDisplay(), previousstartidx);
	if (7 == previouslistingday) previousArray = undefined;
		
	return retValue;
}

function changeNumGroupEntries(amount)
{
	var amt = parseInt(amount);
	numEntriesJetztUndGleich += amt;
	widget.setPreferenceForKey(numEntriesJetztUndGleich, "numGroupEntries");
	takePreparedData();
}

function prepareShowsAndDisplay(channels, starttime, listingday)
{
	var numChannels = 0;
	for (var channel in channels)
	{
		numChannels++;
	}
	if (0 == numChannels)
	{
		switchToPrefSection("channels_form");
		showDialog("F&uuml;r diese Gruppe sind keine Sender definiert", "OK", blendDialogOut, "Definieren", showPrefs);
		stopProgressBar(); // just in case, shouldn't be necessary
		return;
	}
	
	waitingForChannels = channels;
	waitingForTime = starttime;
	waitingForDay = listingday;
	if (("jetzt" == starttime) && (((new Date()).getHours() < 5))) waitingForDay = 8;
	if (("jetztundgleich" == starttime) && (((new Date()).getHours() < 5))) waitingForDay = 8;
	
	startProgressBar();
	
	backgroundCachedData(keysFromHash(channels), waitingForDay, takePreparedData);
}

function takePreparedData()
{
	var numToDisplay = getNumberOfEntriesToDisplay();
	if ((undefined == numToDisplay) || (numToDisplay > 50)) numToDisplay = 50;

	if ("jetztundgleich" == waitingForTime)
	{
		var extras = new Object();
		for (var key in waitingForChannels)
		{
			var thisHeader = new Object();
			if (numEntriesJetztUndGleich > 1) thisHeader["minus"] = "changeNumGroupEntries(-1);";
			thisHeader["plus"] = "changeNumGroupEntries(1);";
			extras[key] = thisHeader;
		}
		displayGroupedShows(getGroupedShows(waitingForChannels, waitingForTime, waitingForDay, numEntriesJetztUndGleich), extras);
	} else {
		displayShows(getShows(waitingForChannels, waitingForTime, waitingForDay, numToDisplay));
	}
	stopProgressBar();
}

function showChannelSchedule(timestamp, channel)
{
	var time = new Date();
	time.setTime(timestamp);
	var hour = time.getHours();
	var minute = time.getMinutes();
	var timeStrg =  (hour < 10 ? "0" : "") + hour + "." + (minute < 10 ? "0" : "") + minute;
	
	var now = new Date();
	now.setHours(hour);
	now.setMinutes(minute);
	now.setSeconds(0);
	
	var listingday = Math.round((time.getTime() - now.getTime()) / 86400000);
	
	if (-1 == listingday) listingday = 8;
	
	var extras = new Object();	
	var thisHeader = new Object();
	thisHeader["cross"] = "updateTVListing();";
	extras[channel] = thisHeader;
	
	var channels = new Object();
	channels[channel] = channel;
		
	displayGroupedShows(getGroupedShows(channels, timeStrg, listingday, getNumberOfEntriesToDisplay()), extras);
}

function getGroupedShows(channels, starttime, listingday, numEntries)
{
	showErrorWhenGettingShows = false;
	errorOccurredWhenGettingShows = false;
	var keyedShows = new Object();

	if ("jetztundgleich" == starttime)
	{
		for (var channel in channels)
		{
			var tmp = new Object();
			tmp[channel] = channels[channel];
			keyedShows[channel] = getShows(tmp, "jetzt", 0, numEntries);
		}
	} else {
		for (var channel in channels)
		{
			var tmp = new Object();
			tmp[channel] = channels[channel];
			keyedShows[channel] = getShows(tmp, starttime, listingday, numEntries);
		}
	}
	showErrorWhenGettingShows = true;
	furtherArray = undefined;
	previousArray = undefined;
	
	if (errorOccurredWhenGettingShows) showDialog("Daten f&uuml;r einige Sender konnten nicht geladen werden, da keine Verbindung zum Internet besteht.<br>Die angezeigten Daten sind unvollst&auml;ndig.", "OK", blendDialogOut);
	
	return keyedShows;
}

// gets all desired Show-data from cache
function getShows(channels, starttime, listingday, numEntries)
{
	var allShows = new Array();
	var keyedShows = new Object();
	listingday = parseInt(listingday);
	
	var showsErrorCaching = new Array();

	// all shows from all (desired) channels from one day go into one array
	for (var channel in channels)
	{
		var shows = cachedData(channel, listingday);
		
		if(!shows)
		{
			if (showErrorWhenGettingShows) showsErrorCaching.push(channel);
			errorOccurredWhenGettingShows = true;
			//alert("Could not retrieve Data for channel " + channel);
			continue;
		} else keyedShows[channel] = shows;

		for (var thisshow in shows)
		{
			allShows.push(thisshow + " " + channel);
		}
	}
	
	if(showsErrorCaching.length > 0) {
		if(allShows.length < 1) {
			if (showErrorWhenGettingShows) showError();
			errorOccurredWhenGettingShows = true;
			//showDialog("Daten der Sender konnten nicht geladen werden", "Nochmal versuchen", updateTVListing, "Netzwerk Diagnose", openDiagnosis);
			return new Array();
		}
		else {
			showDialog("Daten f&uuml;r " + showsErrorCaching.length + " Sender konnten nicht geladen werden, da keine Verbindung zum Internet besteht.<br>Die angezeigten Daten sind unvollst&auml;ndig.", "OK", blendDialogOut);
		}
	}
	
	// sortieren.
	allShows.sort();
	
	var numAllShows = allShows.length;

	var numDeleted = 0;
	var i;
	if ("jetzt" == starttime)
	{
		// find the first show that is running right now
		var now = new Date();
		for (i = 0; i < allShows.length; i++)
		{
			var thisentry = allShows[i];
			var components = thisentry.split(" ");
			var time = components[0];
			components.shift();
			var channel = components.join(" ");
			var temp = keyedShows[channel];
			var thisshow = temp[time];
			
			var thisshowstart = thisshow["timestamp"];
			var thisshowend = thisshow["endtime"];
			
			if ((thisshowstart <= now) && (thisshowend >= now)) break;
			
			// does the channel broadcast 24/7 at all?
			if (0 == i)
			{
				if (thisshowstart > now)
				{
					break;
				}
			}
		}
		
		// get rid of the shows that are over.
		// (they might have started later but are still over)
		for (var j = i; j < allShows.length; j++)
		{
			var components = allShows[j].split(" ");
			var tmpstarttime = components[0];
			components.shift();
			var channel = components.join(" ");
			var temp = keyedShows[channel];
			var thisshow = temp[tmpstarttime];
			
			
			if (now.getTime() > thisshow["endtime"].getTime())
			{
				allShows.splice(j--,1);
				numDeleted++;
			}
		}
	} else {
		var requiredTime = Math.abs(starttime.split(".").join(""));

		for (i = 0; i < allShows.length; i++)
		{
			var showTime = (allShows[i].split(" "))[0];
			var thisTime = Math.abs(showTime.split(".").join(""));
						
			if (thisTime >= requiredTime) {
				break;
			}
		}
	}
	
	var max = i + numEntries;
	var nextDay = 0;
	if (max > allShows.length)
	{
		nextDay = max - allShows.length;
		max = allShows.length;
	}
		
	var retValue = new Array();
	for (var j = i; j < max; j++)
	{
		var thisentry = allShows[j];
		var components = thisentry.split(" ");
		var time = components[0];
		components.shift();
		var channel = components.join(" ");
		var temp = keyedShows[channel];
		var thisshow = temp[time];
		thisshow["time"] = time;
		thisshow["listingday"] = "" + listingday;
		thisshow["channel"] = channel;
		retValue.push(thisshow);
	}
	
	max += numDeleted;
	var furtherstartidx = max;
	var furtherlistingday = listingday;
	if (furtherstartidx >= numAllShows)
	{
		furtherstartidx -= numAllShows;
		furtherlistingday = listingday + 1;
		if (8 == listingday) furtherlistingday = 0;
	}
	var previousstartidx = i - numEntries;
	var previouslistingday = listingday;
	if (0 > previousstartidx)
	{
		// previousstartidx MUST be left negative. getShowsFromArray deals with that.
		// (It couldn't even be dealt with here. The number of shows for the previous day is unknown here.)
		previouslistingday = previouslistingday - 1;
	}

	if (-1 == previouslistingday) previouslistingday = 8;
	furtherArray = new Array (channels, furtherlistingday, getNumberOfEntriesToDisplay(), furtherstartidx);
	if (8 == furtherlistingday) furtherArray = undefined;
	previousArray = new Array (channels, previouslistingday, getNumberOfEntriesToDisplay(), previousstartidx);
	if (7 == previouslistingday) previousArray = undefined;
	
	if (nextDay > 0)
	{
		if (listingday == 7) return retValue;
		if (listingday == 8) listingday = 0;
		else listingday += 1;
		
		var othershows = getShows(channels, ("jetzt" == starttime ? "jetzt" : "00.00"), listingday, nextDay);
		for (var i = 0; i < othershows.length; i++)
		{
			retValue.push(othershows[i]);
		}
	}
	if (-1 == previouslistingday) previouslistingday = 8;
	previousArray = new Array (channels, previouslistingday, getNumberOfEntriesToDisplay(), previousstartidx);
	if (7 == previouslistingday) previousArray = undefined;
	
	return retValue;
}

// displays shows (expects an array with all shows to display)
function displayShows(shows)
{
	if ((undefined != eyetvEnabled) && (eyetvEnabled == 1) && (!isSearchResult)) eyetvIsCurrentlyPlaying = currentStation();
	else eyetvIsCurrentlyPlaying = "";
	
	elapsedTimeCanvasses = new Object();
	if(drawer.current > 0) toggleDrawer();
	purgeParagraphs();
	
	var compDate;

	for(var i = 0; i < shows.length; i++)
	{
		var thisshow = shows[i];
		
		// Set the date at the top
		// Do this for the first show displayed
		// Otherwise, does an "in-between header" have to be displayed?
		if (0 == i)
		{
			var date = shows[0]["timestamp"];
			document.getElementById('showdate').innerText = date.getDate() + "." + (date.getMonth() + 1) + ".";
			compDate = thisshow["timestamp"];
		} else {
			var tmStamp = thisshow["timestamp"];
			if (tmStamp.getDay() != compDate.getDay())
			{
				var dateStrg = printableDate(tmStamp);
				addHeader(dateStrg, new Object());
			}
			compDate = tmStamp;
		}
		
		var description = "";
		if (undefined != thisshow["description"]) description = thisshow["description"];
		var url = "";
		if (undefined != thisshow["url"]) url = thisshow["url"];
		var length = "";
		if (undefined != thisshow["length"]) length = thisshow["length"];
		var icon = "";
		if (undefined != thisshow["icon"]) icon = thisshow["icon"];
		addParagraph(thisshow["time"], thisshow["channel"], thisshow["title"], description, url, icon, length, thisshow["timestamp"]);
	}
	
	//set the opacity (turn on/off) the arrows at the bottom
	if (undefined != furtherArray)
	{
		unblurItem("nextShows");
	} else {
		blurItem("nextShows");
	}
	if (undefined != previousArray)
	{
		unblurItem("previousShows");
	} else {
		blurItem("previousShows");
	}

	document.getElementById('content').style.top = '0px';
	calculateAndShowThumb(document.getElementById('content'));

	stopProgressBar();
	
	forwardCache();
}

function displayGroupedShows(shows, headerExtras)
{
	if ((typeof(shows) != "object") || (shows.length < 1))
	{
		switchToPrefSection('channels_form');
		showDialog("F&uuml;r diese Gruppe sind keine Sender definiert", "OK", blendDialogOut, "Definieren", showPrefs);
		return;
	}
	
	if ((undefined != eyetvEnabled) && (eyetvEnabled == 1) && (!isSearchResult)) eyetvIsCurrentlyPlaying = currentStation();
	else eyetvIsCurrentlyPlaying = "";
	
	elapsedTimeCanvasses = new Object();
	if(drawer.current > 0) toggleDrawer();
	purgeParagraphs();

	var dateSet = false;
	
	for (var group in shows)
	{
		var theseShows = shows[group];
		addHeader(group, headerExtras[group]);
		
		for(var i = 0; i < theseShows.length; i++)
		{
			var thisshow = theseShows[i];
			//alert("title: " + thisshow["title"]);
			var description = "";
			if (undefined != thisshow["description"]) description = thisshow["description"];
			var url = "";
			if (undefined != thisshow["url"]) url = thisshow["url"];
			var length = "";
			if (undefined != thisshow["length"]) length = thisshow["length"];
			var icon = "";
			if (undefined != thisshow["icon"]) icon = thisshow["icon"];
			addParagraph(thisshow["time"], thisshow["channel"], thisshow["title"], description, url, icon, length, thisshow["timestamp"]);
			
			// Set the date at the top
			// Do this for the first show displayed
			if ((0 == i) && (false == dateSet));
			{
				if (isSearchResult)
				{
					document.getElementById('showdate').innerText = "";
				} else {
					var date = theseShows[0]["timestamp"];
					document.getElementById('showdate').innerText = date.getDate() + "." + (date.getMonth() + 1) + ".";
				}
				dateSet = true;
			}
		}
	}
	
	//set the opacity (turn on/off) the arrows at the bottom
	if (undefined != furtherArray)
	{
		unblurItem("nextShows");
	} else {
		blurItem("nextShows");
	}
	if (undefined != previousArray)
	{
		unblurItem("previousShows");
	} else {
		blurItem("previousShows");
	}

	document.getElementById('content').style.top = '0px';
	calculateAndShowThumb(document.getElementById('content'));

	stopProgressBar();
}

function getURL(requesturl)
{
	if (currentlyloading) return;
	currentlyloading = true;
	
	if(drawer.current > 0) toggleDrawer();
	previousShowObject = null;
	previousShowClass = null;
	
	startProgressBar();

	req = new XMLHttpRequest();
	req.onreadystatechange = processReqChange;
	req.open("GET", requesturl, true);
	req.setRequestHeader("Cache-Control", "no-cache");

	req.send(null);
}

function processReqChange()
{
	if (req.readyState == 4) currentlyloading = false;
	if ((req.readyState == 4) && (req.status == undefined) && isSearchResult)
	{
		if (alreadySearchedInCache) 
		{
			searchInCache();
		} else showDialog("Es besteht keine Verbindung zum Internet.<br>M&ouml;chten Sie im Cache suchen?<br>Die Ergebnisse k&ouml;nnten unnvollst&auml;ndig sein.", "Ignorieren", blendDialogOut, "Im Cache suchen", searchInCache);
		return;
	}
	if ((req.readyState == 4) && (req.status == undefined)) showError();
	if ((req.readyState == 4) && (req.status >= 200) && (req.status < 400)) 
	{
		alreadySearchedInCache = false;
		parseRawHTML(req.responseText);
	}
	// DEBUG ONLY!
	// if ((req.readyState == 4) && (req.status >= 400)) showError();
}

function showError()
{
	hideDrawer();
	showDialog("Ein Netzwerkfehler ist aufgetreten.<br /><br />Bitte &uuml;berpr&uuml;fen Sie die Netzwerkeinstellungen.", "Ignorieren", blendDialogOut, "Netzwerk-Diagnose...", openDiagnosis);
}

function updateTVListing()
{
	if(dialogShown) blendDialogOut();

	startProgressBar();

	isSearchResult = false;
	isQuickAccessSearch = false;

	selectValue(document.getElementById('shortcuts'), "-");

	document.getElementById("searchInput").value="";
	
	var channels;
	if ("main" == getDefaultChannelGroup()) channels = channels_main;
	else if ("two" == getDefaultChannelGroup()) channels = channels_two;
	else channels = mergeHashes(channels_main, channels_two);
	
	prepareShowsAndDisplay(channels, getListingTime(), getListingDay());
}

var dateFirstShow;
function parseRawHTML(rawsource)
{
	// Das alles zu einer Zeile machen 
	var dateFirstShow;
	lines = rawsource.split("\n");
	rsource = lines.join("");
	
	if (document.getElementById('helpdiv').style.display == 'block') hideHelp();
	
	if (isSearchResult && (rsource.indexOf("Der gesuchte Text ist in den Titeln der TV-Sendungen von gestern") != -1))
	{
		purgeParagraphs();
		stopProgressBar();
		document.getElementById('content').style.top = '0px';
		document.getElementById('content').innerHTML = "<div class=\"notFound\">Keine Sendung gefunden</div>";
		calculateAndShowThumb(document.getElementById('content'));
		return;
	}
	
	elapsedTimeCanvasses = new Array();

	try {
		// mal datum finden
		
		datematch = /((ContentAd Ende)|(Ende ContentAd)).*?<span class="headline-balken">&nbsp;&nbsp;P R O G R A M M.*?<span class="text-weiss">([0-9]{1,2}\.[0-9]{1,2}\.)[0-9]{2}([0-9]{2}).*?<\/span>/;
		datematch.exec(rsource);
		dateFirstShow = RegExp.$4;
	
		dateFirstShow += RegExp.$5;
		document.getElementById('showdate').innerText = "";
				
		// Der entscheidende Teil für das Fernsehprogramm...
		//rmatch = /((ContentAd Ende)|(Ende ContentAd)).*?<\/table>.*?<img[^>]+><br>(.*?)<img[^>]+><br><br><table[^>]+width="566">(.*)$/;
		rmatch = /((ContentAd Ende)|(Ende ContentAd)).*?<\/table>.*?<img[^>]+><br>(.*?)<img src="\/tv\/bilder\/linie.gif" width="100%" height="1" border="0"><br><br><table border="0" cellpadding="2" cellspacing="2" width="100%"><tr>(.*)$/;
	
		rmatch.exec(rsource);
		var listing = RegExp.$4;
		
		// relevant later-on for "frhere Sendungen" und "weitere Sendungen"
		var afterlisting = RegExp.$5;
		
		//alert(listing);
		//alert("---");
		//alert(afterlisting);
		
		shows = new Array();
		showsregexp = /<table border="0" cellpadding="4" cellspacing="0" width="585">\s?<tr>(.*?)<\/tr>/g;
		rawshows = listing.match(showsregexp);
		
		var startstamp;
		var searchdate;
		
		// Loop through the single shows
		for (i = 0; i < rawshows.length; i++)
		{
			//alert("show "+i);
			//alert(rawshows[i]);
		
			singleshowregexp = /<td.*?>.*?<\/td>/g;
			thisshow = rawshows[i].match(singleshowregexp);
			
			//alert(thisshow);
			
			iconurlregexp = /<td width="38" valign="top"><img src="([^"]*)" [^>]*alt="/;
			iconurlraw = thisshow[0].match(iconurlregexp);
			iconurl = iconurlraw[1];
			
			//alert(iconurl);
			
			/*******************************
			 * Start the Date/Time parsing *
			 *******************************/
			
			// get Date tvtoday delivers us on top of all the programs and make a stamp
			if(firstShowStamp == undefined) {
				var tempDateArr = (dateFirstShow.split("."));
				firstShowStamp = new Date();
				firstShowStamp.setYear(2000 + Math.abs(tempDateArr[2]));
				firstShowStamp.setMonth(tempDateArr[1] - 1);
				firstShowStamp.setDate(tempDateArr[0]);
				
				daysPastMidnight = 0;
			}
			
			startstamp = new Date(firstShowStamp.getTime());
			
			starttimeregexp = /<td valign="top" bgcolor="#a8a8a8"><span class="text-grau">([^>]*?)<br>([^>]*?)<\/span/;
			starttimeraw = thisshow[1].match(starttimeregexp);
			starttime = starttimeraw[1];
			startstamp = starttimeraw[2];
			
			previousShowTime = starttime;
			
			/*
			 * End Date/Time
			 */
						
			shownameregexp = /<td valign="middle" width="509"><span class="headline">(<a href.*?><u>)?(.*?)(<\/u>)?<\/span><span class="text">(.*?)\s.*?<\/span>.*?<span class="text">(.*?)\s.*?<\/span>/;
			shownameraw = thisshow[2].match(shownameregexp);
			shownameandchannel = shownameraw[2];
			
			showurlregexp = /<td valign="middle" width="509"><span class="headline">.*?openWindowLupeCustom\('([^']*?)',/;
			showurlraw = thisshow[2].match(showurlregexp);
			var showurl = null;
			if (showurlraw != null) showurl = showurlraw[1];
			
			showchannelregexp = /(.*)\s*\((....*)\)/
			showchannel = shownameandchannel.match(showchannelregexp);
			
			showname = showchannel[1];
			channel = showchannel[2];
			
			// mit showview
			//showdescregexp = /<td valign="middle" width="476">.*?<span class="text">\s*?<i>(.*?)\s*?<br>\s*?<\/span>.*?<span class="text">\s*?(.*?)\s*?(<br>)?\s*?<\/span>/;
			// ohne showview -- aber wer braucht das?
			showdescregexp = /<td valign="middle" width="509">.*?<span class="text">\s*?<i>(.*?)<\/i>.*?<\/span>.*?<span class="text">\s*?(.*?)\s*?(<br>)?\s*?<\/span>/;
			showdescraw = thisshow[2].match(showdescregexp);
			
			showlength = "";
			showlength = showdescraw[1];
			showdesc = "";
			
			if (undefined != showdescraw[2]) showdesc += showdescraw[2];
			
			show = new Array(channel, starttime, showname, iconurl, showdesc, showlength, startstamp);
			if (showurl != null) show.push(showurl);
			shows[i] = show;
		}
				
		/**********************************
		 feed addParagraph() with the shows
		 **********************************/
		if ((undefined != eyetvEnabled) && (eyetvEnabled == 1) && (!isSearchResult)) eyetvIsCurrentlyPlaying = currentStation();
		else eyetvIsCurrentlyPlaying = "";
		
		purgeParagraphs();
		var lastSearchedMonth;
		var thisSearchedMonth;
		for (i = 0; i < shows.length; i++)
		{
			thisshow = shows[i];
			showtitle = thisshow[2];
			longdesc = "";

			showdate = thisshow[6];
			if (lastSearchDate != showdate)
			{
				addDateHeader(showdate);
				lastSearchDate = showdate;
			}
			if (thisshow.length == 8) longdesc = thisshow[7];
			var dateElements = showdate.split(".");
			var timeElements = thisshow[1].split(".");
			//alert(showdate + " >> " + dateElements);
			
			thisSearchedMonth = Math.abs(dateElements[1]) - 1;
			
			var timestamp = new Date(firstShowStamp.getYear() + (thisSearchedMonth < lastSearchedMonth ? 1901 : 1900), thisSearchedMonth, Math.abs(dateElements[0]), Math.abs(timeElements[0]), Math.abs(timeElements[1]), 0);
			
			addParagraph(thisshow[1], thisshow[0], showtitle, thisshow[4], longdesc, thisshow[3], thisshow[5], timestamp);
			lastSearchedMonth = thisSearchedMonth;
		}
		
		// Gibt es weitere oder vorherige Sendungen?
		
		previousregexp = /<a href="([^"]*)"><span class="link-intern"><img[^>]+bilder\/pfeil_links.gif[^>]+>&nbsp;fr&uuml;here Sendungen/;
		previousraw = afterlisting.match(previousregexp);
		previous = null;
		if (previousraw != undefined) previous = previousraw[1];
			
		furtherregexp = /<a href="([^"]*)"><span class="link-intern"> weitere Sendungen/;
		furtherraw = afterlisting.match(furtherregexp);
		further = null;
		if (furtherraw != undefined) further = furtherraw[1];
		
		if (previous == null) blurItem("previousShows");
		else unblurItem("previousShows");
		
		if (further == null) blurItem("nextShows");
		else unblurItem("nextShows");
		
		stopProgressBar();
		
		document.getElementById('content').style.top = '0px';
		calculateAndShowThumb(document.getElementById('content'));
	}
	
	// error catched
	catch(exc)
	{	
		showDialog("Beim Analysieren der Daten von TVToday ist ein Fehler aufgetreten.<br /><br />Dies kann unterschiedliche Ursachen haben, der wahrscheinlichste ist da&szlig; TVToday das Format seiner Seiten ver&auml;ndert hat.<br />In diesem Fall k&ouml;nnen Sie nur auf ein Update seitens der Entwickler warten", "Erneut versuchen", updateTVListing, "Webseite &ouml;ffnen", gotoWebsite);
		
		document.getElementById('content').style.top = '0px';
		blurItem("previousShows");
		blurItem("nextShows");
		
		alert("Fehler beim parsen des Programms (Source " + rawsource.length + " Zeichen): " + exc);
	}
}

function gotoWebsite() {
	if(window.widget) { 
		widget.openURL("http://www.sebastian-krauss.de/software");
	}
}

function toggleShow(showName, time, channel, iconurl, buttonID)
{
	button = document.getElementById(buttonID);

	if (FernsehPlugin.alarmExistsForShow(showName, channel, time)) 
	{
		button.setAttribute("src", "Images/AlarmOff.png");
		button.setAttribute('title', 'Alarm ist aus');
		FernsehPlugin.removeAlarmForShow(showName, channel, time);
	} else {
		button.setAttribute("src", "Images/AlarmOn.png");
		button.setAttribute('title', 'Alarm ist an');
		var eyetvchannel = eyetvChannels[channel];
		if (undefined == eyetvchannel) eyetvchannel = "";	
		FernsehPlugin.setAlarmForShow(showName, channel, time, iconurl, eyetvchannel);
	}
}

function toggleRowId(element, button, event)
{
	// toggle ALL descriptions
	if (event.altKey)
	{
		var showAll = element.nextSibling.style.display != 'block';
		
		var elements = document.getElementById("content").childNodes;
		for (i = 0; i < elements.length; i++)
		{
			if(elements[i].getAttribute("class") == "descRow") {
				elements[i].style.display = (showAll ? 'block' : 'none');
				elements[i-1].lastChild.src = (showAll ? 'Images/iButtonGrau.png' : 'Images/iButton.png');
			}
		}
	}
	
	// toggle single description
	else {
		var nextelem = element.nextSibling;
		
		if (nextelem.style.display == 'block')
		{
			nextelem.style.display = 'none';
			button.src='Images/iButton.png';
		} else {
			nextelem.style.display = 'block';
			button.src='Images/iButtonGrau.png';
		}
	}
	
	calculateAndShowThumb(document.getElementById('content'));
}


var alternateParagraph = false;
function addParagraph(i_time, i_channel, i_title, i_desc, i_moreinfo, i_iconurl, i_showlength, i_showTimeStamp)
{
	var parent = document.getElementById('content');
	// main <p>
	
	if ((undefined == i_title) || ("" == i_title)) i_title = "Name der Sendung fehlt";
	
	// DEBUG
	//i_title = i_showTimeStamp;
	
	var paragraph = document.createElement('p');
	var main_class = document.createAttribute('class');
	main_class.nodeValue = alternateParagraph ? 'mainRow2' : 'mainRow';
	paragraph.setAttributeNode(main_class);

	alternateParagraph = !alternateParagraph;
	
	var listingday = isSearchResult ? listingDayFromSearchDate() : getListingDay();
	if (isQuickAccessSearch) listingday = quickAccessDay;
	
	/* *** all the shortinfo in one box *** */
	var infoPanel = document.createElement('div');
	infoPanel.setAttribute('class', "infopanel");
	
	// create the alarm-icon (a canvas actually)
	var alarmCanBeSet = ((new Date()).getTime() < i_showTimeStamp.getTime());
	var alarmExists = FernsehPlugin.alarmExistsForShow(i_title, i_channel, i_showTimeStamp.getTime());
	
	var checkbox = document.createElement('img');
	checkbox.setAttribute('class', "reminder");
	
	var canvasid = "-";
	var timeelapsed;
	
	if (!alarmCanBeSet)
	{
		if (i_showlength != "")
		{
			var showlengthparts = i_showlength.split(" ");
			showlength = Math.abs(showlengthparts[0]);
			var showlengthIsValid = true;
			
			// if no showlength is given, try to calculate			
			if(showlength == 0) {
				if(showlengthparts[3]) {
					var showLastsUntil = showlengthparts[3].split(".");
					showLastsUntil[0] = (showLastsUntil[0] < i_showTimeStamp.getHours()) ? Math.abs(showLastsUntil[0] + 24) : showLastsUntil[0];
					var tempShowLength = ((showLastsUntil[0] * 60) + Math.abs(showLastsUntil[1])) - ((i_showTimeStamp.getHours() * 60) + Math.abs(i_showTimeStamp.getMinutes()));
					tempShowLength = (tempShowLength > 6*60) ? 25 : ((tempShowLength < 1) ? 25 : tempShowLength);	// just to be sure
					
					showlengthIsValid = true;
					showlength = Math.floor(tempShowLength / 60) + "." + (tempShowLength % 60);
					i_showlength = tempShowLength + i_showlength;
					//alert(showlength + " " + i_showlength);
				}
				else {
					showlengthIsValid = false;
					var title = "Keine Laufzeit";
					checkbox.setAttribute('title', title);
				}
			}
			
			// we have a showlength
			if(showlength != 0) {
				var elapsed = ((new Date()).getTime() - i_showTimeStamp.getTime()) / 60000;
				
				timeelapsed = elapsed/showlength;
				
				var title = minutesAsString(showlength) + " Gesamtlaufzeit\n" + minutesAsString(Math.ceil(timeelapsed*showlength)) + " gelaufen\n" + minutesAsString(showlength-Math.ceil(timeelapsed*showlength)) + " verbleibend";
				if (timeelapsed > 1)
				{
					title = "Sendung vorbei";
					timeelapsed = 1;
				}
	
				checkbox = document.createElement('canvas');
				checkbox.setAttribute('class', "reminder");
				var canvasid = "canvas-" + currentID++;
				checkbox.setAttribute('id', canvasid);
				checkbox.setAttribute('title', title);
				
				elapsedTimeCanvasses[canvasid] = "" + timeelapsed;
				//alert("canvasid "+canvasid+" >> timeelapsed "+timeelapsed);
   			}
		} else {
			 checkbox.setAttribute('src', 'Images/ProgramRunning.png');
			 checkbox.setAttribute('title', 'Sendung läuft');
		}
	} else {
		if (alarmExists)
		{
				checkbox.setAttribute('src', 'Images/AlarmOn.png');
				checkbox.setAttribute('title', 'Alarm ist an');
		} else {
				checkbox.setAttribute('src', 'Images/AlarmOff.png');
				checkbox.setAttribute('title', 'Alarm ist aus');
		}
		var thisButtonID = "buttonID"+currentID++;
		checkbox.setAttribute("id", thisButtonID);
		checkbox.setAttribute("onclick", "toggleShow(\"" + i_title + "\",\"" + i_showTimeStamp.getTime() + "\",\"" + i_channel + "\",\"" + i_iconurl + "\",\"" + thisButtonID + "\");");
	}
	
	// create the eyeTV-Button (only if eyetv is activated)
	if((eyetvEnabled != undefined) && (eyetvEnabled == 1)) {
		var eyetv_knob = document.createElement('img');
		
		// show is currently running
		if((undefined != eyetvChannels[i_channel]) && !alarmCanBeSet)
		{
			eyetv_knob.setAttribute("id", "playingButton_" + i_channel);
			eyetv_knob.setAttribute("src", (i_channel == eyetvIsCurrentlyPlaying) ? "Images/EyeTV_playing.png" : "Images/EyeTV_readyToPlay.png");
			eyetv_knob.setAttribute("onclick", "switchToRunningShow(\"" + i_channel + "\", this);");
			eyetv_knob.setAttribute('title', 'Sender einschalten');
		} else if (undefined != eyetvChannels[i_channel]) {
			// show can be recorded
			var showAlreadyScheduled = FernsehPlugin.eyeTVTimerExistsForChannel(eyetvChannels[i_channel], ""+i_showTimeStamp.getTime());

			if (showAlreadyScheduled)
			{
				eyetv_knob.setAttribute("src", "Images/EyeTV_recording.png");
				eyetv_knob.setAttribute("onclick", "deleteRecordTimerForShow(\"" + i_channel + "\", \"" + i_title+ "\", \"" + (i_showlength.split(" "))[0] + "\", this, " + i_showTimeStamp.getTime() + ");");
				eyetv_knob.setAttribute('title', 'Sendung wird aufgenommen');
			} else {
				eyetv_knob.setAttribute("src", "Images/EyeTV_readyToRecord.png");
				eyetv_knob.setAttribute("onclick", "setRecordTimerForShow(\"" + i_channel + "\", \"" + i_title+ "\", \"" + (i_showlength.split(" "))[0] + "\", this, " + i_showTimeStamp.getTime() + ");");
				eyetv_knob.setAttribute('title', 'Sendung aufnehmen');
			}
		} else {
			// show is not available within eyetv
			eyetv_knob.setAttribute("src", "Images/EyeTV_notAvail.png");
		}
		eyetv_knob.setAttribute("class", "eyetvPlaynow");
		if(timeelapsed >= 1)
			eyetv_knob.setAttribute("style", "opacity:0.0;");		// hide if show is over
		
		checkbox.setAttribute("style", "left:0px;");
		paragraph.setAttribute("style", "padding-left:62px");
	}
	
	// create the time
	var time = document.createElement('span');
	time.setAttribute('class', "time");
	var time_data = document.createTextNode(i_time);
	time.appendChild(time_data);
	if (!isSearchResult)
	{
		var hour = i_showTimeStamp.getHours();
		var minute = i_showTimeStamp.getMinutes();
		var timeStrg =  (hour < 10 ? "0" : "") + hour + "." + (minute < 10 ? "0" : "") + minute;
		
		var now = new Date();
		now.setHours(hour);
		now.setMinutes(minute);
		now.setSeconds(0);
		
		var lday = Math.round((i_showTimeStamp.getTime() - now.getTime()) / 86400000);
		
		if (-1 == lday) lday = 8;
		time.setAttribute("onclick", "prepareShowsAndDisplay(waitingForChannels,\""+timeStrg+"\",\""+lday+"\");");
	}
	
	// create channel
	var channel = document.createElement('span');
	channel.setAttribute("class", isSearchResult ? "channel" : "channel channelhover");
	var channel_data = document.createTextNode(i_channel);
	channel.appendChild(channel_data);
	if (!isSearchResult)
	{
		channel.setAttribute("onclick", "showChannelSchedule(\""+i_showTimeStamp.getTime()+"\",\""+i_channel+"\");");
	}
	
	// put it together
	infoPanel.appendChild(checkbox);
	if(eyetv_knob)
		infoPanel.appendChild(eyetv_knob);
	infoPanel.appendChild(time);
		
	paragraph.appendChild(infoPanel);
	
	// title
	var title_data = document.createTextNode(i_title);
	if(i_moreinfo != "")
	{
		var title_link = document.createElement('a');
		var paraID = "infoParagraphID" + currentID++;
		title_link.setAttribute("href", 'javascript:getShowDescription("' + i_moreinfo + '", "' + paraID + '");');
		paragraph.setAttribute('id', paraID);
		title_link.appendChild(title_data);
		paragraph.appendChild(title_link);
	} else {
		paragraph.appendChild(title_data);
	}
	
	paragraph.appendChild(channel);
	
	// togglebutton
	if(i_desc || i_showlength)
	{
		if (!i_desc) i_desc = "<br>";
		var descs = i_desc.split("<br>");     // !!! NOT <br />
		var showDescOn = document.getElementById("kurzInfoStandard").checked;
		var img = document.createElement("img");
		if (showDescOn) img.setAttribute("src", "Images/iButtonGrau.png");
		else img.setAttribute("src", "Images/iButton.png");
		img.setAttribute("class", "toggleshortinfo");
		img.setAttribute("onclick", "toggleRowId(this.parentNode, this, event)");
		
		paragraph.appendChild(img);
	
		// moreinfo
		var desc = document.createElement('p');
		var desc_class = document.createAttribute('class');
		desc_class.nodeValue = 'descRow';
		var desc_data = document.createTextNode(descs[0]);
		
		desc.setAttributeNode(desc_class);
		
		if (showDescOn) desc.style.display = 'block';
		
		desc.appendChild(desc_data);
		
		// "<br>anschl. Nachrichten"
		for (z = 1; z < descs.length; z++)
		{
			desc.appendChild(document.createElement("br"));
			var textnode = document.createTextNode(descs[z]);
			desc.appendChild(textnode);
		}
		
		if (i_showlength != "")
		{
			// if available, add the length of the show below the short desc
			var showlength = document.createElement('span');
			var showlength_class = document.createAttribute('class');
			showlength_class.nodeValue = 'showlength';
			
			showlength.setAttributeNode(showlength_class);
			showlength.appendChild(document.createTextNode(i_showlength));
			
			desc.appendChild(showlength);
		}
	}
	
	// append
	parent.appendChild(paragraph);
	if (i_desc || i_showlength) parent.appendChild(desc);
	if (canvasid != "-") drawElapsed(canvasid, timeelapsed);
}

function minutesAsString(minutes)
{
	var result = Math.floor(minutes / 60) + ":";
	var remMins = (minutes % 60);
				
	if (remMins < 10) result += "0" + remMins
	else result += remMins;
	
	return result;
}

function drawElapsed(canvasid, timeelapsed)
{
	var canvas = document.getElementById(canvasid);
	var context = canvas.getContext("2d");
	context.clearRect(0,0,12,12);
	context.beginPath();
	context.arc(6, 6, 5.5, 0, 6.2831853072, true);
	context.closePath();
		
	context.lineWith = 0.3;
	context.setStrokeColor("#999999");
	context.stroke();
	
	context.setFillColor("#FFFFFF");
	context.fill();

	if (timeelapsed > 0)
	{
		context.beginPath();
		context.moveTo(6, 6);
		// -1.5707963268 ^=  -90 degrees, 12 o'clock on a watch in this case
		context.arc(6, 6, 5.5, -1.5707963268, (timeelapsed * 6.2831853072) - 1.5707963268, false);
		context.closePath();
		context.setFillColor("#888888");
		context.fill();
	}
}

// work around a bug in webkit
function redrawElapsed()
{
	for (var canvasid in elapsedTimeCanvasses)
	{
		drawElapsed(canvasid, parseFloat(elapsedTimeCanvasses[canvasid]));
	}
}

function addHeader(headername, headerExtras)
{
	var parent = document.getElementById('content');
	
	// main <p>
	var paragraph = document.createElement('p');
	paragraph.setAttribute("class", "dateRow");
	var headerTitle = document.createTextNode(headername);
	paragraph.appendChild(headerTitle);
	
	if(typeof(headerExtras) == "object")
	{
		var container = document.createElement("div");
		container.setAttribute("class", "extraHeaderUtilities");
		
		for (var key in headerExtras)
		{
			var extra = document.createElement("img");
			var divID = "extra" + currentID++;
			container.setAttribute("id", divID);
			extra.setAttribute("src", "Images/" + key + ".png");
			extra.setAttribute("onmousedown", "blurItem(this)");
			extra.setAttribute("onmouseout", "unblurItem(this)");
			extra.setAttribute("onclick", headerExtras[key]);
			extra.setAttribute("class", "extraHeaderItem");
			container.appendChild(extra);
		}
		
		paragraph.appendChild(container);
	}

	parent.appendChild(paragraph);
}

function addDateHeader(date)
{
	var parent = document.getElementById('content');
	
	// main <p>
	var paragraph = document.createElement('p');
	paragraph.setAttribute("class", "dateRow");
	
	var components = date.split(".");
	var showday = Math.abs(components[0]);
	var showmonth = Math.abs(components[1])-1; // months are 1 off, [0..11]
	
	var now = new Date();
	
	var nowDate = new Date(now.getFullYear(), now.getMonth(), now.getDate());
	var showDate = new Date(now.getFullYear(), showmonth, showday);
	
	// next year, search took place end december, result in january
	if (showmonth < now.getMonth()) showDate.setFullYear(now.getFullYear()+1);
		
	var longDate = localizedWeekday(showDate) + ", " + date;
	
	var date_data = document.createTextNode(longDate);
	
	paragraph.appendChild(date_data);
	parent.appendChild(paragraph);
}


function purgeParagraphs() {
	var parent = document.getElementById('content');
	var elements = parent.childNodes;
	var a = elements.length;
	
	for(i = a-1; i >= 0; i--) {
		if(elements[i] != null)
			parent.removeChild(elements[i]);
	}
}

function listingDayFromSearchDate()
{
	var components = lastSearchDate.split(".");
	var showday = Math.abs(components[0]);
	var showmonth = Math.abs(components[1])-1; // months are 1 off, [0..11]
	
	var now = new Date();
	
	var nowDate = new Date(now.getFullYear(), now.getMonth(), now.getDate());
	var showDate = new Date(now.getFullYear(), showmonth, showday);
	
	// next year, search took place end december, result in january
	if (showmonth < now.getMonth()) showDate.setFullYear(now.getFullYear()+1);
	
	var daysbetween = (showDate - nowDate) / 86400000;
	
	return daysbetween;
}

function getShowDescription(requesturl, callingID)
{
	if (currentlyloading) return;
	currentlyloading = true;
	
	callingobj = document.getElementById(callingID);
	
	if (null != previousShowObject)
	{
		previousShowObject.setAttribute('class', previousShowClass);
	}
	previousShowObject = callingobj;
	previousShowClass = previousShowObject.getAttribute("class");
	callingobj.setAttribute('class', 'highlightrow');

	document.getElementById('drawercontent').innerHTML = "<div class=\"faded\">Lade Beschreibung...</div>";
	resizeDrawer();
	
	currentShowDescURL = requesturl;

	req = new XMLHttpRequest();
	req.onreadystatechange = parseShowDescription;
	req.open("GET", requesturl, true);
	req.setRequestHeader("Cache-Control", "no-cache");
	req.send(null);
}

function parseShowDescription()
{
	if (req.readyState == 4) currentlyloading = false;
	if ((req.readyState == 4) && (req.status == undefined))
	{
		document.getElementById('drawercontent').innerHTML = "";
		resizeDrawer();

		showError();
		return;
	}
	if (!((req.readyState == 4) && (req.status >= 200) && (req.status < 400))) return;
	
	var show = "";
	try
	{
		rawShow = req.responseText;
		lines = rawShow.split("\n");
		rsource = lines.join("");
		
		showregexp = /<\/table>\s*<span class="text">(.*?)\s*<\/span/;
		showraw = rsource.match(showregexp);
		show = showraw[1];
		
		// sometimes they link to descriptions, but the description is "xxx".
		// instead of displaying "xxx" as description, say that there is none.
		if (show.length < 6)
		{
			show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>";
			document.getElementById('drawercontent').innerHTML = show;
			resizeDrawer();
			return;
		}
		
		var startsearch = (show.length / 2) + 1;
		var doSearch = true;
		
		while (doSearch)
		{
			var thischar = show.charAt(--startsearch);
			if ((thischar == ' ') || (thischar == '.')) doSearch = false;
			
			if (startsearch == 0) doSearch = false;
		}
		
		show = show.substring(0, startsearch);
		show += "&hellip;<br /><a href=\"javascript:widget.openURL('" + currentShowDescURL + "');\">Mehr &#187;</a>";
	} catch (exc) {
		// Happens if there is no description. Honestly.
		show = "<div class=\"faded\">Keine Beschreibung vorhanden.</div>"; 
	}
	
	document.getElementById('drawercontent').innerHTML = show;
	resizeDrawer();
}

function showPrevious()
{
	blurItem("nextShows");
	blurItem("previousShows");
	if (isSearchResult)
	{
		if (previous == null) return;
		lastSearchDate = "";
		previousNumPages = numNextPages;
		numNextPages--;
		getURL("http://programm.tvtoday.de" + previous);
	} else {
		if (undefined == previousArray) return;
		startProgressBar();
		var prevListingDay = previousArray[1];
		var channels = keysFromHash(previousArray[0]);
		if (!cachedDataAvailable(channels, prevListingDay))
		{
			backgroundCachedData(channels, prevListingDay, noop);
		}
		displayShows(getShowsFromArray(previousArray));
	}
}

function showNext()
{
	blurItem("nextShows");
	blurItem("previousShows");
	if (true == isSearchResult)
	{
		if (further == null) return;
		lastSearchDate = "";
		previousNumPages = numNextPages;
		numNextPages++;
		getURL("http://programm.tvtoday.de" + further);
	} else {
		if (undefined == furtherArray) return;
		startProgressBar();
		var nextListingDay = furtherArray[1];
		nextListingDay++;
		if (nextListingDay == 9) nextListingDay = 0;
		var channels = keysFromHash(furtherArray[0]);
		if (!cachedDataAvailable(channels, nextListingDay))
		{
			backgroundCachedData(channels, nextListingDay, noop);
		}
		displayShows(getShowsFromArray(furtherArray));
	}
}

function scrollwheel(event, whatdiv)
{
	if (scrollTrack.style.display == 'none') return;
	delta = window.event.wheelDelta/10;
	// delta > 0 rad nach oben
	// delta < 0 rad nach unten
	
	var newv = (parseInt(whatdiv.style.top.replace(/px/, ''))) + delta;
	newv += 'px';
	whatdiv.style.top = newv;
	calculateAndShowThumb(whatdiv);
}

function reminderIntervalChanged()
{
	var opt = document.getElementById("erinnerung");
	var optval = opt.options[opt.selectedIndex].value;

	if (FernsehPlugin) FernsehPlugin.setSecondsBeforeReminder(""+optval);
}

function searchInCache()
{
	blendDialogOut();
	startProgressBar();
	
	alreadySearchedInCache = true;
	var searchString = document.getElementById('searchInput').value.toLowerCase();
	
	// Bloede umlaute
	searchString = escape(searchString);
	//alert(searchString);
	searchString = searchString.replace(/%E4/g, "a%u0308"); // ae
	searchString = searchString.replace(/%F6/g, "o%u0308"); // oe
	searchString = searchString.replace(/%FC/g, "u%u0308"); // ue
	searchString = unescape(searchString);
	
	var allChannels = keysFromHash(channels_main).concat(keysFromHash(channels_two));
	
	var showsFound = 0;
	var result = new Object();
	var allShows = new Object();
	for (var day = 0; day < 8; day++)
	{
		var showsThisDay = new Array();
		for (var chCounter = 0; chCounter < allChannels.length; chCounter++)
		{
			var thisChannel = allChannels[chCounter];
			if (!cachedDataAvailable(new Array(thisChannel), day)) continue;
			var shows = cachedData(thisChannel, day);
			var keyedShowsDay = new Object();
			for (var key in shows)
			{
				var thisshow = shows[key];
				var title = thisshow["title"].toLowerCase();
				
				var desc = "";
				if (undefined != thisshow["description"]) desc = thisshow["description"].toLowerCase();
				
				if ((title.indexOf(searchString) != -1) || (desc.indexOf(searchString) != -1)) 
				{
					showsThisDay.push(key + " " + thisChannel);
					keyedShowsDay[key] = thisshow;
					showsFound++;
				}
			}
			allShows[thisChannel] = keyedShowsDay;
		}
		
		if (showsThisDay.length > 0)
		{
			showsThisDay.sort();
			var sortedShows = new Array();
			
			for (var i = 0; i < showsThisDay.length; i++)
			{
				var thisshow = showsThisDay[i];
				var components = thisshow.split(" ");
				var time = components[0];
				components.shift();
				var channel = components.join(" ");
				var tmp = allShows[channel];
				var foundShow = allShows[channel][time];
				foundShow["channel"] = channel;
				foundShow["time"] = time;
				sortedShows.push(foundShow);
			}
			var date = sortedShows[0]["timestamp"];
			var dateStrg = printableDate(date);
			result[dateStrg] = sortedShows;
		}
	}
	if (showsFound > 0) displayGroupedShows(result, new Object());
	else {
		purgeParagraphs();
		stopProgressBar();
		document.getElementById('content').style.top = '0px';
		document.getElementById('content').innerHTML = "<div class=\"notFound\">Keine Sendung gefunden</div>";
		calculateAndShowThumb(document.getElementById('content'));
	}
}

function searchShow(searchstring)
{
	var waitUntilExpand = false;
	if (!isSearchResult && (searchstring == "")) return;
	if (isCollapsed())
	{
		toggleWidget();
		waitUntilExpand = true;
	}
	if (searchstring == "")
	{
		if (isSearchResult) updateTVListing();
		return;
	}
	
	lastSearchDate = "";
	isSearchResult = true;
	isQuickAccessSearch = false;
	var requrl = "http://programm.tvtoday.de/tv/programm/programm.php?ztag=0&uhrzeit=jetzt&sparte=alle&sender=HS&suchbegriff="+escape(searchstring);
	
	setTimeout("getURL(\"" + requrl + "\");", waitUntilExpand ? expandCollapseTime + 50 : 0);
}

function showHelp()
{
	blendDialogOut();
	var front = document.getElementById("frontDiv");
	var back = document.getElementById("prefDiv");
	
	if(back.style.display == "block") {
		if(window.widget)
			widget.prepareForTransition("ToFront");
					
		front.style.display = "block";
		back.style.display = "none";
		
		if(window.widget)
			setTimeout("widget.performTransition();", 0);
	}
	
	document.getElementById("helpdiv").style.display = 'block';
	document.getElementById("content").style.display = 'none';
	document.getElementById("searchInput").style.display = 'none';
	document.getElementById("toggledrawer").style.display = 'none';
	document.getElementById("shortcutscover").style.display = 'none';
	document.getElementById("shortcuts").style.display = 'none';
	document.getElementById("pages").style.display = 'none';
	
	// create closehelp-button
	var hdiv = document.createElement("a");
	hdiv.setAttribute("id", "closeHelp");
	hdiv.setAttribute("href", "javascript:hideHelp();");
	hdiv.setAttribute("onmousedown", "blurItem(this);");
	hdiv.setAttribute("onmouseout", "unblurItem(this);");
	hdiv.innerHTML = "Hilfe schlie&szlig;en";
	
	var ldiv = document.createElement("div");
	ldiv.setAttribute("class", "left");
	var rdiv = document.createElement("div");
	rdiv.setAttribute("class", "right");
	
	hdiv.appendChild(ldiv);
	hdiv.appendChild(rdiv);
	document.getElementById("title").appendChild(hdiv);
	
	calculateAndShowThumb(document.getElementById('helpdiv'));
}

function hideHelp()
{
	if(document.getElementById('helpdiv').style.display != "block")
		return;
	
	if(null != previous)
		document.getElementById('previousShows').style.display = 'block';
	if(null != further)
		document.getElementById('nextShows').style.display = 'block';
	(document.getElementById("title")).removeChild(document.getElementById("closeHelp"));
	document.getElementById("toggledrawer").style.display = 'block';
	document.getElementById("searchInput").style.display = 'inline';
	document.getElementById("shortcutscover").style.display = 'block';
	document.getElementById("shortcuts").style.display = 'block';
	document.getElementById("helpdiv").style.display = 'none';
	document.getElementById("pages").style.display = 'block';
	
	updateTVListing();

	document.getElementById('content').style.display = 'block';
	calculateAndShowThumb(document.getElementById('content'));
	selectValue(document.getElementById('shortcuts'), previousChosenShortcut);
	redrawElapsed();
}

function shortcutChosen()
{
	var opt = document.getElementById('shortcuts')
	var optval = opt.options[opt.selectedIndex].value;
	
	if (optval == "")
	{
		selectValue(opt, previousChosenShortcut);
		return;
	}

	blurItem("nextShows");
	blurItem("previousShows");

	if (optval == "helpFAQ")
	{
		showHelp();
		return;
	}
	previousChosenShortcut = optval;
	if (optval == "-")
	{
		updateTVListing();
		return;
	}
	
	var options = optval.split("/");
	
	isSearchResult = false;
	document.getElementById("searchInput").value="";
	var day = options[0];
	var hour = options[1];
	var channel = options[2];
	
	if ("primetime" == hour)
	{
		// Primetime CH: 20.00
		//          D/A: 20.15
		if ("CH" == currentLocale()) hour = "20.00";
		else hour = "20.15";
	}
	
	isQuickAccessSearch = true;
	quickAccessDay = day;
	quickAccessHour = hour;
	
	var channels;
	if ("main" == channel) channels = channels_main;
	else if ("two" == channel) channels = channels_two;
	else channels = mergeHashes(channels_main, channels_two);
	
	prepareShowsAndDisplay(channels, quickAccessHour, quickAccessDay);

}

function timerSoundChanged()
{
	var opt = document.getElementById("alarmton");
	var optval = opt.options[opt.selectedIndex].value;

	if (FernsehPlugin) FernsehPlugin.setTimerSound(optval);
}
